//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class bestanswer_hook_badfTopicSource extends _HOOK_CLASS_
{
	/**
	 * Can user set the best answer?
	 *
	 * @param	\IPS\Member	$member	The member (null for currently logged in member)
	 * @return	bool
	 */
	public function canSetBestAnswerPlugin( \IPS\Member $member = NULL )
	{
		try
		{
			try
			{
				try
				{
					try
					{
						/* Archived topics cannot be modified */
						if ( $this->isArchived() )
						{
							return FALSE;
						}
				
						/* If we asked this question, we can set the best answer */
						$member = $member ?: \IPS\Member::loggedIn();
				
						if ( ( $member == $this->author() AND \IPS\Settings::i()->resolvedForums_authorSetAsBestAnswer OR \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->resolvedForums_setAsBestAnswer ) ) ) AND !in_array( $this->container()->_id, explode( ',', \IPS\Settings::i()->resolvedForums ) ) )
						{
							return TRUE;
						}
				
						/* Or if we're a moderator */
						if( \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->resolvedForums_setAsBestAnswer ) ) )		
						{
							return TRUE;
						}
				
						/* Otherwise no */
						return FALSE;
					}
					catch ( \RuntimeException $e )
					{
						if ( method_exists( get_parent_class(), __FUNCTION__ ) )
						{
							return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
						}
						else
						{
							throw $e;
						}
					}
				}
				catch ( \RuntimeException $e )
				{
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	public function checkForum( $id )
	{	
			try
			{
				try
				{
					try
					{
						try
						{
						if( !in_array( $id, explode( ',', \IPS\Settings::i()->resolvedForums ) ) )
						{
							return TRUE;
						}
				
						return FALSE;
					}
					catch ( \RuntimeException $e )
					{
						if ( method_exists( get_parent_class(), __FUNCTION__ ) )
						{
							return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
						}
						else
						{
							throw $e;
						}
					}
				}
				catch ( \RuntimeException $e )
				{
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}