<?php


namespace IPS\bestanswer\modules\admin\settings;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * settings
 */
class _settings extends \IPS\Dispatcher\Controller
{
	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'settings_manage' );

		$form = $this->getForm();

		if ( $values = $form->values( TRUE ) )
		{
			$form->saveAsSettings( $values );
			\IPS\Session::i()->log( 'acplogs__bestanswer_settings' );
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('settings');
		\IPS\Output::i()->output = $form;
	}

	/**
	 * Build and return the settings form
	 *
	 * @note	Abstracted to allow third party devs to extend easier
	 * @return	\IPS\Helpers\Form
	 */
	protected function getForm()
	{
		$form = new \IPS\Helpers\Form;

		$form->add( new \IPS\Helpers\Form\YesNo( 'resolvedForums_authorSetAsBestAnswer', \IPS\Settings::i()->resolvedForums_authorSetAsBestAnswer ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'resolvedForums_lockTopics', \IPS\Settings::i()->resolvedForums_lockTopics, FALSE ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'resolvedForums_unlockTopics', \IPS\Settings::i()->resolvedForums_unlockTopics, FALSE ) );
		
		$form->add( new \IPS\Helpers\Form\Select( 'resolvedForums_setAsBestAnswer', \IPS\Settings::i()->resolvedForums_setAsBestAnswer == '*' ? "*" : explode( ',', \IPS\Settings::i()->resolvedForums_setAsBestAnswer ), FALSE, array( 'options' => \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal', 'multiple' => true ), NULL, NULL, NULL, 'resolvedForums_setAsBestAnswer' ) );
		
		$form->add( new \IPS\Helpers\Form\Node( 'resolvedForums', ( \IPS\Settings::i()->resolvedForums ) ? explode( ',', \IPS\Settings::i()->resolvedForums ) : 0, FALSE, array( 'class' => 'IPS\forums\Forum', 'multiple' => TRUE, 'clubs'	=> TRUE ), NULL, NULL, NULL, 'resolvedForums' ) );

		return $form;
	}
}