<?php
/**
 * @brief		badfLatestBestAnswers Widget
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	bestanswer
 * @since		18 Sep 2017
 */

namespace IPS\bestanswer\widgets;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * badfLatestBestAnswers Widget
 */
class _badfLatestBestAnswers extends \IPS\Widget\PermissionCache
{
	/**
	 * @brief	Widget Key
	 */
	public $key = 'badfLatestBestAnswers';
	
	/**
	 * @brief	App
	 */
	public $app = 'bestanswer';
		
	/**
	 * @brief	Plugin
	 */
	public $plugin = '';
	
	/**
	 * Initialise this widget
	 *
	 * @return void
	 */ 
	public function init()
	{
		$this->configuration['badfLatestBestAnswers_nr'] = isset( $this->configuration['badfLatestBestAnswers_nr'] ) ? $this->configuration['badfLatestBestAnswers_nr'] : 5;

		parent::init();
	}
	
	/**
	 * Specify widget configuration
	 *
	 * @param	null|\IPS\Helpers\Form	$form	Form object
	 * @return	null|\IPS\Helpers\Form
	 */
	public function configuration( &$form=null )
	{
  		$form = parent::configuration( $form );
 
		$form->add( new \IPS\Helpers\Form\Number( 'badfLatestBestAnswers_nr', isset( $this->configuration['badfLatestBestAnswers_nr'] ) ? $this->configuration['badfLatestBestAnswers_nr'] : 5, TRUE, array( 'min' => 1 ) ) );


		return $form;
 	} 
 	
 	 /**
 	 * Ran before saving widget configuration
 	 *
 	 * @param	array	$values	Values from form
 	 * @return	array
 	 */
 	public function preConfig( $values )
 	{
 		return $values;
 	}

	/**
	 * Render a widget
	 *
	 * @return	string
	 */
	public function render()
	{
		$bestAnswer[] = array( 'topic_answered_pid>0' );
		$topics = \IPS\forums\Topic::getItemsWithPermission( $bestAnswer, 'topic_answered_pid DESC', $this->configuration['badfLatestBestAnswers_nr'] );

		return $this->output( $topics );
	}
}